extern function printf void( string, double);
// ... Variable argument list functions are beyond the scope of this intro

class Employee
{
	string name;
	int age;
	double salary;

	function setSalary void( double salary_)
	{
		salary = salary_;
	}
}

function salarySum double( Employee[10] list)
{
	var int idx = 0;
	var double sum = 0.0;
	while (idx < 10 && list[idx].age)
	{
		sum = sum + list[idx].salary;
		idx = idx + 1;
	}
	return sum;
}

function salaryRaise void( Employee[10] list, double percentRaise)
{
	var int idx = 0;
	var double factor = 1 + (percentRaise / 100);
	while (idx < 10 && list[idx].age)
	{
		list[idx].setSalary( list[idx].salary * factor);
		idx = idx + 1;
	}
}

main
{
	var Employee[ 10] list = {
		{"John Doe", 36, 60000},
		{"Suzy Sample", 36, 63400},
		{"Doe Joe", 36, 64400},
		{"Sandra Last", 36, 67400}
	};
	salaryRaise( list, 10);					// Give them all a 10% raise
	printf( "Salary sum: %.2f\n", salarySum( list));	// Expected result = 280720
}

